/*
* JBoss, Home of Professional Open Source
* Copyright 2005, JBoss Inc., and individual contributors as indicated
* by the @authors tag. See the copyright.txt in the distribution for a
* full listing of individual contributors.
*
* This is free software; you can redistribute it and/or modify it
* under the terms of the GNU Lesser General Public License as
* published by the Free Software Foundation; either version 2.1 of
* the License, or (at your option) any later version.
*
* This software is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this software; if not, write to the Free
* Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
* 02110-1301 USA, or see the FSF site: http://www.fsf.org.
*/
package org.jboss.invocation.pooled.server;

/**
 * MBean interface.
 */
public interface PooledInvokerMBean extends org.jboss.system.ServiceMBean {

   /**
    * Getter for property numAcceptThreads
    * @return Value of property numAcceptThreads
    */
  int getNumAcceptThreads() ;

   /**
    * Setter for property numAcceptThreads
    * @param size New value of property numAcceptThreads.
    */
  void setNumAcceptThreads(int size) ;

   /**
    * Getter for property maxPoolSize;
    * @return Value of property maxPoolSize.
    */
  int getMaxPoolSize() ;

   /**
    * Setter for property maxPoolSize.
    * @param maxPoolSize New value of property maxPoolSize.
    */
  void setMaxPoolSize(int maxPoolSize) ;

   /**
    * Getter for property maxPoolSize;
    * @return Value of property maxPoolSize.
    */
  int getClientMaxPoolSize() ;

   /**
    * Setter for property maxPoolSize.
    * @param clientMaxPoolSize New value of property serverBindPort.
    */
  void setClientMaxPoolSize(int clientMaxPoolSize) ;

   /**
    * Getter for property timeout
    * @return Value of property timeout
    */
  int getSocketTimeout() ;

   /**
    * Setter for property timeout
    * @param time New value of property timeout
    */
  void setSocketTimeout(int time) ;

  int getCurrentClientPoolSize() ;

  int getCurrentThreadPoolSize() ;

   /**
    * Getter for property serverBindPort.
    * @return Value of property serverBindPort.
    */
  int getServerBindPort() ;

   /**
    * Setter for property serverBindPort.
    * @param serverBindPort New value of property serverBindPort.
    */
  void setServerBindPort(int serverBindPort) ;

  java.lang.String getClientConnectAddress() ;

  void setClientConnectAddress(java.lang.String clientConnectAddress) ;

  int getClientConnectPort() ;

  void setClientConnectPort(int clientConnectPort) ;

  int getBacklog() ;

  void setBacklog(int backlog) ;

  boolean isEnableTcpNoDelay() ;

  void setEnableTcpNoDelay(boolean enableTcpNoDelay) ;

  java.lang.String getServerBindAddress() ;

  void setServerBindAddress(java.lang.String serverBindAddress) ;

  java.lang.String getClientSocketFactoryName() ;

  void setClientSocketFactoryName(java.lang.String clientSocketFactoryName) ;

  java.lang.String getServerSocketFactoryName() ;

  void setServerSocketFactoryName(java.lang.String serverSocketFactoryName) ;

  javax.net.SocketFactory getClientSocketFactory() ;

  void setClientSocketFactory(javax.net.SocketFactory clientSocketFactory) ;

  java.net.ServerSocket getServerSocket() ;

  void setServerSocket(java.net.ServerSocket serverSocket) ;

  java.lang.String getSslDomain() ;

  void setSslDomain(java.lang.String sslDomain) ;

  javax.net.ServerSocketFactory getServerSocketFactory() ;

  void setServerSocketFactory(javax.net.ServerSocketFactory serverSocketFactory) ;

   /**
    * mbean get-set pair for field transactionManagerService Get the value of transactionManagerService
    * @return value of transactionManagerService
    */
  javax.management.ObjectName getTransactionManagerService() ;

   /**
    * Set the value of transactionManagerService
    * @param transactionManagerService Value to assign to transactionManagerService
    */
  void setTransactionManagerService(javax.management.ObjectName transactionManagerService) ;

  org.jboss.invocation.pooled.interfaces.PooledInvokerProxy getOptimizedInvokerProxy() ;

}
